import numpy
import theano
import theano.tensor as T
from theano import pp




x = T.dscalar('x')
y = T.dscalar('y')
z = x + y
f = theano.function([x, y], z)
print(pp(z))
f(2, 3)



x = T.dmatrix('x')
y = T.dmatrix('y')
z = x + y
f = theano.function([x, y], z)
print f(numpy.array([[1, 2], [3, 4]]), numpy.array([[10, 20], [30, 40]]))



a = theano.tensor.vector() # declare variable
out = a + a ** 10               # build symbolic expression
f = theano.function([a], out)   # compile function
print(f([0, 1, 2]))


#------------- Logistic function

x = T.dmatrix('x')
s = 1 / (1 + T.exp(-x))
logistic = theano.function([x], s)
print logistic([[0, 1], [-1, -2]])


#-------------- Much more complicated example - multiple outputs
a, b = T.dmatrices('a', 'b')
diff = a - b
abs_diff = abs(diff)
diff_squared = diff**2
f = theano.function([a, b], [diff, abs_diff, diff_squared])

out = f([[1, 1], [1, 1]], [[0, 1], [2, 3]])

print out[0]
print out[1]
print out[2]


#----------- Random Numbers

from theano.tensor.shared_randomstreams import RandomStreams
srng = RandomStreams(seed=234)
rv_u = srng.uniform((10,10))
rv_n = srng.normal((20,2))
f = theano.function([], rv_u)
g = theano.function([], rv_n, no_default_updates=True)    #Not updating rv_n.rng
nearly_zeros = theano.function([], rv_u + rv_u - 2 * rv_u)


A=f()
B=f()

x = T.dmatrix('x')
y = T.dmatrix('y')
z = x + y
fsum = theano.function([x, y], z)

print fsum(A,B)



#===============================================================



x = T.dscalar('x')
y = x ** 2
gy = T.grad(y, x)
pp(gy)  # print out the gradient prior to optimization
f = theano.function([x], gy)
print f(4)



pass

x = T.dmatrix('x')
s = T.sum(1 / (1 + T.exp(-x)))
gs = T.grad(s, x)
dlogistic = theano.function([x], gs)
print dlogistic([[0, 1], [-1, -2]])
 
