import numpy
import theano
import theano.tensor as T
from theano import pp

 


x = T.dscalar('x')
y = x ** 2
gy = T.grad(y, x)
pp(gy)  # print out the gradient prior to optimization
f = theano.function([x], gy)
print f(4)

 
 
#------------- logistic loss and it's gradient 
x = T.dmatrix('x')
s = T.sum(1 / (1 + T.exp(-x)))
gs = T.grad(s, x)
dlogistic = theano.function([x], gs)
print dlogistic([[0, 1], [-1, -2]])
 
 
 
f = theano.function([x], [s, gs])
val = f([[0, 1], [-1, -2]])
print val[0]
print val[1]


#--------------- Jacobian
x = T.dvector('x')
y = x ** 2
J, updates = theano.scan(lambda i, y,x : T.grad(y[i], x), sequences=T.arange(y.shape[0]), non_sequences=[y,x])
f = theano.function([x], J, updates=updates)
print f([4, 4])

#--------------- Hessian
x = T.dvector('x')
y = x ** 2
cost = y.sum()
gy = T.grad(cost, x)
H, updates = theano.scan(lambda i, gy,x : T.grad(gy[i], x), sequences=T.arange(gy.shape[0]), non_sequences=[gy, x])
f = theano.function([x], H, updates=updates)
print f([4, 4])

#------------ Automated Differentiation
#R-operator
#The R operator is built to evaluate the product between a Jacobian and a vector

